﻿Imports System.Runtime.InteropServices

Public Class Propeller

    Public Declare Sub Init Lib "Propellent" Alias "InitPropellent" (ByVal hWin As UInt32, ByVal storeprefs As Boolean, ByVal regpath As Long)
    Private Declare Function glv Lib "Propellent" Alias "GetLibraryVersion" () As Long
    Private Declare Function EditPorts Lib "Propellent" Alias "ShowEditPorts" () As IntPtr
    Private Declare Function SetGUIMode Lib "Propellent" Alias "SetGUIMode" (ByVal mode As Byte) As IntPtr
    Private Declare Function FinalizeDLL Lib "Propellent" Alias "FinalizePropellent" () As IntPtr

    Dim hwnd As IntPtr

    <DllImport("Propellent", EntryPoint:="DownloadToPropeller", SetLastError:=True, _
           CharSet:=CharSet.Unicode, ExactSpelling:=True, _
           CallingConvention:=CallingConvention.StdCall)> _
    Public Shared Sub DownLoad( _
           ByVal src As IntPtr, _
           ByVal cmd As Byte)
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        Dim x As String = Nothing
        hwnd = Me.Handle
        Init(hwnd, False, x)

    End Sub



    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        Dim cmd As Byte = 1 ' values can be to 1, 2 or 3 (ram, eeprom/norun, eeprom/run)
        Dim ptr As IntPtr
        Dim returnValue As String = " "
        ptr = Marshal.StringToHGlobalUni(returnValue)

        Me.Cursor = Cursors.WaitCursor
        Button1.Text = "Downloading..."
        DownLoad(ptr, cmd)
        Button1.Text = "Download"
        Me.Cursor = Cursors.Default

    End Sub

    Private Sub Button2_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        EditPorts()
    End Sub

    Private Sub Button3_Click_1(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        MsgBox(glv().ToString())
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        Dim mode As Byte = 0 ' values are 0, 1, 2 or 3 (default, status, dialogs, off)
        SetGUIMode(mode)
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        Dim mode As Byte = 3 ' values are 0, 1, 2 or 3 (default, status, dialogs, off)
        SetGUIMode(mode)
    End Sub

    Protected Overrides Sub Finalize()
        FinalizeDLL()
        MyBase.Finalize()
    End Sub
End Class
